<?php
/**
 * @file
 * FileField Authcode widget hooks.
 * We enterly rely on Filefield for the display.
 */
function filefield_authcode_widget_settings_form($widget) {
  $form = module_invoke('filefield', 'widget_settings', 'form', $widget);
  $prefix = variable_get('file_directory_path', 'files') . '/filefield_authcode';
  $form['path_settings']['file_path'] = array(
      '#type' => textfield,
      '#default_value' => is_string($widget['file_path']) ? trim(str_replace('filefield_authcode', '', $widget['file_path']), '/') : str_replace('field_', '', arg(5)),
      '#size' => '60',
      '#description' => t('By default, files will be stored within %prefix/%field_name. You can optionally change/add/remove subdirectories. <br />
     Do not include preceding or trailing slashes.', array('%prefix' => $prefix, '%field_name' => str_replace('field_', '', arg(5)))),
      '#element_validate' => array_merge($form['path_settings']['file_path']['#element_validate'], array('_filefield_authcode_widget_settings_path_validate',)),
      '#field_prefix' => $prefix . '/',
  );
  return $form;
}

function _filefield_authcode_widget_settings_path_validate($element, &$form_state) {
  $auth_base_path = file_directory_path() . '/filefield_authcode';
  if (empty($form_state['values']['file_path'])) {
    $auth_value_path = 'filefield_authcode';
    $auth_full_path = $auth_base_path;
  }
  else {
    $auth_value_path = 'filefield_authcode/' . $form_state['values']['file_path'];
    $auth_full_path = file_directory_path() . '/' . $auth_value_path;
  }
  if (!field_file_check_directory($auth_base_path, FILE_CREATE_DIRECTORY, NULL)) {
    form_set_error(t('Could not create directory "%destination". Check if destination is writable by the server.', array('%destination' => $auth_base_path)));
  }
  global $base_path;
  $h = fopen($auth_base_path . '/.htaccess', "w+t");
  $m = "<IfModule mod_rewrite.c> \nRewriteEngine on \nRewriteBase " . $base_path . "filefield_authcode \nRewriteRule ^(.*)$ $1 [L,R=301] \n</IfModule>";
  if (!fwrite($h, $m)) {
    form_set_error(t('Could not create ".htaccess" file in "%destination". Check if destination is writable by the server.', array('%destination' => $auth_base_path)));
  }

  if (!field_file_check_directory($auth_full_path, FILE_CREATE_DIRECTORY, NULL)) {
    form_set_error(t('Could not create directory "%destination". Check if destination is writable by the server.', array('%destination' => $auth_full_path)));
  }
  $form_state['values']['file_path'] = $auth_value_path;
}

function filefield_authcode_widget_settings_save($widget) {
  $filefield_settings = module_invoke('filefield', 'widget_settings', 'save', $widget);
  return $filefield_settings;
}

function filefield_authcode_widget_value($element, $edit = FALSE) {

  $item = filefield_widget_value($element, $edit);

  return $item;
}

function filefield_authcode_widget_process($element, $edit, &$form_state, $form) {
  $element = filefield_widget_process($element, $edit, $form_state, $form);

  return $element;
}

function theme_filefield_authcode_widget($element) {

  return theme('form_element', $element, $element['#children']);
}

function theme_filefield_authcode_widget_item($element) {

  return theme('filefield_widget_item', $element);
}